# Ha Visual Studio Code-ban dolgozunk:
#   váltsunk át a Python 2.7-es értelmezőre
#   import arcpy

# a következő sor módosítandó:
munkamappa = "s:/Oktatás, tanulás/Oktatás, tanulás 2022_23_2_tavasz/Desktop GIS/gyakorlat/09 Eszközök készítése Pythonnal 1/kimenet"
import arcpy.management as man

# DEMO 1
print(man.GetCount(in_rows = "patakok")) # osszes patak: 14988
man.SelectLayerByAttribute(
	in_layer_or_view = "patakok",
	selection_type = "NEW_SELECTION",
	where_clause = "\"NAME\" = 'Zala 100/102' OR \"FID\" < 2"
) # kivalasztunk, escape character
print(man.GetCount(in_rows = "patakok")) # kivalasztott patakok: 3
man.SelectLayerByAttribute(
	in_layer_or_view = "patakok",
	selection_type = "CLEAR_SELECTION"
) # kivalasztas megszuntetese

# DEMO 2
""""NAME" = 'Zala 100/102' OR "FID" < 2"""
print(""""NAME" = 'Zala 100/102' OR "FID" < 2""") # megjelenitve (escape character feloldva)
man.SelectLayerByAttribute(
	in_layer_or_view = "patakok",
	selection_type = "NEW_SELECTION",
	where_clause = """"NAME" = 'Zala 100/102' OR "FID" < 2"""
) # kivalasztunk harmas idezojalben

# DEMO 3
"Beszurok valami szoveget ide: {}. Meg ide is: {}.".format("egy", "ketto") # szoveget behelyettesit
"Beszurok valami szoveget ide: {}. Meg ide is: {}.".format('harom', 'negy')
"Beszurok valami szoveget ide: {}. Meg ide is: {}.".format('"ot"', '[hat]') # hatarolo jellel
'Beszurok valami szoveget ide: {}. Meg ide is: {}.'.format("'het'", '"nyolc"') # escape charactert automatikusan berak
"""Beszurok valami szoveget ide: {}. Meg ide is: {}.""".format('"kilenc"', "'tiz'")
print("""Beszurok valami szoveget ide: {}. Meg ide is: {}.""".format('"kilenc"', "'tiz'")) # megjelenitve (escape character feloldva)

# DEMO 4
print("{} = {} OR {} < {}".format('"NAME"', "'Zala 100/102'", '"FID"', "2"))
man.SelectLayerByAttribute(
	in_layer_or_view = "patakok",
	selection_type = "NEW_SELECTION",
	where_clause = "{} = {} OR {} < {}".format('"NAME"', "'Zala 100/102'", '"FID"', "2")
)

# Feladat 1
man.SelectLayerByAttribute(
	in_layer_or_view = "patakok",
	selection_type = "ADD_TO_SELECTION",
	where_clause = "{} LIKE {} AND {} = {}".format('"NAME"', "'M%'", '"SIZE_CAT"', "' '")
)
print(man.GetCount(in_rows = "patakok")) # kivalasztott patakok: 17

# DEMO 5
man.CreatePersonalGDB(
	out_folder_path = munkamappa,
	out_name = "minta_geoadatbazis.mdb"
) # ures mdb-fajl letrehozasa
man.CreateFileGDB(
	out_folder_path = munkamappa,
	out_name = "minta_geoadatbazis.gdb"
) # ures gdb-fajl letrehozasa
man.SelectLayerByAttribute(
	in_layer_or_view = "patakok",
	selection_type = "CLEAR_SELECTION"
) # kivalasztas megszuntetese
arcpy.conversion.FeatureClassToFeatureClass(
	in_features = "patakok",
	out_path = munkamappa + "/minta_geoadatbazis.mdb",
	out_name = "patakok_mdbben"
) # mdb-be masol vektorreteget, automatikusan TOC-hoz adodik
arcpy.conversion.FeatureClassToFeatureClass(
	in_features = "patakok",
	out_path = munkamappa + "/minta_geoadatbazis.gdb",
	out_name = "patakok_gdbben"
) # gdb-be masol vektorreteget, automatikusan TOC-hoz adodik
# ha nem adodott volna a TOC-hoz, vagy pl. toroltuk:
man.MakeFeatureLayer(
	in_features = munkamappa + "/minta_geoadatbazis.gdb/patakok_gdbben",
	out_layer = "patakok_gdbben"
) # ideiglenes vektorreteget keszit (vagyis a TOC-hoz adja/hivatkozhatova teszi)

# DEMO 6
man.SelectLayerByAttribute(
	in_layer_or_view = "patakok_gdbben",
	selection_type = "NEW_SELECTION",
	where_clause = """"SIZE_CAT" = 'kicsi'"""
) # kivalasztas shp-ben
print(man.GetCount(in_rows = "patakok_gdbben")) # kivalasztott patakok: 3634
print(man.GetCount(in_rows = "patakok_mdbben")) # osszes patak: 14988
man.SelectLayerByAttribute(
	in_layer_or_view = "patakok_mdbben",
	selection_type = "NEW_SELECTION",
	where_clause = """"SIZE_CAT" = 'kicsi'"""
) # kivalasztas mdb-retegben
print(man.GetCount(in_rows = "patakok_mdbben")) # 0, nem sikerult a kivalasztas
man.SelectLayerByAttribute(
	in_layer_or_view = "patakok_mdbben",
	selection_type = "NEW_SELECTION",
	where_clause = """[SIZE_CAT] = 'kicsi'"""
) # kivalasztas mdb-retegben
print(man.GetCount(in_rows = "patakok_mdbben")) # 3634, sikerult a kivalasztas

# DEMO 7
print(arcpy.AddFieldDelimiters(datasource = "patakok", field = "SIZE_CAT")) # "SIZE_CAT"
print(arcpy.AddFieldDelimiters(datasource = munkamappa + "/minta_geoadatbazis.gdb/patakok_gdbben", field = "SIZE_CAT")) # SIZE_CAT
print(arcpy.AddFieldDelimiters(datasource = munkamappa + "/minta_geoadatbazis.mdb/patakok_mdbben", field = "SIZE_CAT")) # [SIZE_CAT]
print(arcpy.AddFieldDelimiters(datasource = munkamappa + "/minta_geoadatbazis.mdb", field = "SIZE_CAT")) # [SIZE_CAT]

# DEMO 8
"""{} = 'kicsi'""".format(arcpy.AddFieldDelimiters("patakok", "SIZE_CAT"))
keresokifejezes = """{} = {} AND NOT ({} LIKE {})""".format(
	arcpy.AddFieldDelimiters(datasource = munkamappa + "/minta_geoadatbazis.gdb/patakok_gdbben", field = "SIZE_CAT"),
	"' '",
	arcpy.AddFieldDelimiters(datasource = munkamappa + "/minta_geoadatbazis.gdb/patakok_gdbben", field = "NAME"),
	"'Rába%'"
)
print(keresokifejezes) # SIZE_CAT = ' ' AND NOT (NAME LIKE 'Rába%')

man.SelectLayerByAttribute(
	in_layer_or_view = "patakok_gdbben",
	selection_type = "NEW_SELECTION",
	where_clause = keresokifejezes
) # kivalasztas gdb-retegben
print(man.GetCount(in_rows = "patakok_gdbben")) # 285


# Feladat 2
reteg_helye = munkamappa + "/minta_geoadatbazis.mdb/patakok_mdbben"
keresokifejezes = """{} = {} OR {} <> {}""".format(
	arcpy.AddFieldDelimiters(datasource = reteg_helye, field = "NAME"),
	"'Duna 105/119'",
	arcpy.AddFieldDelimiters(datasource = reteg_helye, field = "SIZE_CAT"),
	"'nagy'"
)
print(keresokifejezes) # [NAME] = 'Duna 105/119' OR [SIZE_CAT] <> 'nagy'
man.SelectLayerByAttribute(
	in_layer_or_view = "patakok_mdbben",
	selection_type = "NEW_SELECTION",
	where_clause = keresokifejezes
) # kivalasztas mdb-retegben
print(man.GetCount(in_rows = "patakok_mdbben")) # 3939

