import arcpy
import arcpy.management as man

bemeneti_fajl_vagy_reteg = arcpy.GetParameterAsText(0)
mezonev = arcpy.GetParameterAsText(1)
kimeneti_vektorfajl = arcpy.GetParameterAsText(2)

keresokifejezes = """{} IS NOT NULL""".format(arcpy.AddFieldDelimiters(datasource = bemeneti_fajl_vagy_reteg, field = mezonev))
arcpy.AddMessage("A kovetkezo keresokifejezes futtatasa elkezdodott: " + keresokifejezes)
man.MakeFeatureLayer(
	in_features = bemeneti_fajl_vagy_reteg,
	out_layer = "ideiglenes_vektorreteg"
)
man.SelectLayerByAttribute(
	in_layer_or_view = "ideiglenes_vektorreteg",
	selection_type = "NEW_SELECTION",
	where_clause = keresokifejezes
)
darabszam = str(man.GetCount(in_rows = "ideiglenes_vektorreteg"))
arcpy.AddMessage("A nem ures elemek (" + darabszam + " db) levalogatasa megtortent, a mentes megkezdodott.")
man.CopyFeatures(
	in_features = "ideiglenes_vektorreteg",
	out_feature_class = kimeneti_vektorfajl
)
